const db = require('../models/db');

exports.getMovieInformations = (req, res, next) => {
    let filmId = req.params.id;

    db.query('SELECT * FROM Film WHERE tconst = ?',
        [filmId], function (error, results, fields) {

            if (error) {
                res.status(500).json({ error });
            } else {
                let infos = results[0];
                res.status(200).json(infos);
            }
        })
};

exports.searchMovie = (req, res, next) => {
    let search = req.query.title;

    db.query('SELECT * FROM Film WHERE primaryTitle LIKE CONCAT("%",?,"%") OR titleFR LIKE CONCAT("%",?,"%")',
        [search, search], function (error, results, fields) {
            if(error) {
                res.status(500).json({error});
            }
            else {
                let searchResults = results;
                res.status(200).json(searchResults);
            }
        })

};

exports.getRecentlyReleasedMovies = (req, res, next) => {
    const numberOfMovies = req.query.numberOfMovies || 20;

    db.query('SELECT * FROM Film WHERE releaseDate <= CURDATE() ORDER BY releaseDate DESC LIMIT ?',
        [parseInt(numberOfMovies)], (error, results, fields) => {
            if (error) {
                res.status(500).json({ error });
            } else {
                res.status(200).json(results);
            }
        });
};
exports.getMovieCast = (req, res, next) => {
    let filmId = req.params.id;

    db.query('SELECT * FROM roles r JOIN personne p on r.nconst=p.nconst WHERE r.tconst = ?',
        [filmId], function (error, results, fields) {

            if (error) {
                res.status(500).json({ error });
            } else {
                let infos = results;
                res.status(200).json(infos);
            }
        })
};